#
k8s_openapi/v1_35/api/core/v1/
empty_dir_volume_source.rs

    1// Generated from definition io.k8s.api.core.v1.EmptyDirVolumeSource
    2
    3/// Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.
    4#[derive(Clone, Debug, Default, PartialEq)]
    5pub struct EmptyDirVolumeSource {
    6    /// medium represents what type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
    7    pub medium: Option<std::string::String>,
    8
    9    /// sizeLimit is the total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
    10    pub size_limit: Option<crate::apimachinery::pkg::api::resource::Quantity>,
    11}
    12
    13impl crate::DeepMerge for EmptyDirVolumeSource {
    14    fn merge_from(&mut self, other: Self) {
    15        crate::DeepMerge::merge_from(&mut self.medium, other.medium);
    16        crate::DeepMerge::merge_from(&mut self.size_limit, other.size_limit);
    17    }
    18}
    19
    20impl<'de> crate::serde::Deserialize<'de> for EmptyDirVolumeSource {
    21    fn deserialize<D>(deserializer: D) -> Result<Self, D::Error> where D: crate::serde::Deserializer<'de> {
    22        #[allow(non_camel_case_types)]
    23        enum Field {
    24            Key_medium,
    25            Key_size_limit,
    26            Other,
    27        }
    28
    29        impl<'de> crate::serde::Deserialize<'de> for Field {
    30            fn deserialize<D>(deserializer: D) -> Result<Self, D::Error> where D: crate::serde::Deserializer<'de> {
    31                struct Visitor;
    32
    33                impl crate::serde::de::Visitor<'_> for Visitor {
    34                    type Value = Field;
    35
    36                    fn expecting(&self, f: &mut core::fmt::Formatter<'_>) -> core::fmt::Result {
    37                        f.write_str("field identifier")
    38                    }
    39
    40                    fn visit_str<E>(self, v: &str) -> Result<Self::Value, E> where E: crate::serde::de::Error {
    41                        Ok(match v {
    42                            "medium" => Field::Key_medium,
    43                            "sizeLimit" => Field::Key_size_limit,
    44                            _ => Field::Other,
    45                        })
    46                    }
    47                }
    48
    49                deserializer.deserialize_identifier(Visitor)
    50            }
    51        }
    52
    53        struct Visitor;
    54
    55        impl<'de> crate::serde::de::Visitor<'de> for Visitor {
    56            type Value = EmptyDirVolumeSource;
    57
    58            fn expecting(&self, f: &mut core::fmt::Formatter<'_>) -> core::fmt::Result {
    59                f.write_str("EmptyDirVolumeSource")
    60            }
    61
    62            fn visit_map<A>(self, mut map: A) -> Result<Self::Value, A::Error> where A: crate::serde::de::MapAccess<'de> {
    63                let mut value_medium: Option<std::string::String> = None;
    64                let mut value_size_limit: Option<crate::apimachinery::pkg::api::resource::Quantity> = None;
    65
    66                while let Some(key) = crate::serde::de::MapAccess::next_key::<Field>(&mut map)? {
    67                    match key {
    68                        Field::Key_medium => value_medium = crate::serde::de::MapAccess::next_value(&mut map)?,
    69                        Field::Key_size_limit => value_size_limit = crate::serde::de::MapAccess::next_value(&mut map)?,
    70                        Field::Other => { let _: crate::serde::de::IgnoredAny = crate::serde::de::MapAccess::next_value(&mut map)?; },
    71                    }
    72                }
    73
    74                Ok(EmptyDirVolumeSource {
    75                    medium: value_medium,
    76                    size_limit: value_size_limit,
    77                })
    78            }
    79        }
    80
    81        deserializer.deserialize_struct(
    82            "EmptyDirVolumeSource",
    83            &[
    84                "medium",
    85                "sizeLimit",
    86            ],
    87            Visitor,
    88        )
    89    }
    90}
    91
    92impl crate::serde::Serialize for EmptyDirVolumeSource {
    93    fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error> where S: crate::serde::Serializer {
    94        let mut state = serializer.serialize_struct(
    95            "EmptyDirVolumeSource",
    96            self.medium.as_ref().map_or(0, |_| 1) +
    97            self.size_limit.as_ref().map_or(0, |_| 1),
    98        )?;
    99        if let Some(value) = &self.medium {
    100            crate::serde::ser::SerializeStruct::serialize_field(&mut state, "medium", value)?;
    101        }
    102        if let Some(value) = &self.size_limit {
    103            crate::serde::ser::SerializeStruct::serialize_field(&mut state, "sizeLimit", value)?;
    104        }
    105        crate::serde::ser::SerializeStruct::end(state)
    106    }
    107}
    108
    109#[cfg(feature = "schemars")]
    110impl crate::schemars::JsonSchema for EmptyDirVolumeSource {
    111    fn schema_name() -> std::borrow::Cow<'static, str> {
    112        "io.k8s.api.core.v1.EmptyDirVolumeSource".into()
    113    }
    114
    115    fn json_schema(__gen: &mut crate::schemars::SchemaGenerator) -> crate::schemars::Schema {
    116        crate::schemars::json_schema!({
    117            "description": "Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.",
    118            "type": "object",
    119            "properties": {
    120                "medium": {
    121                    "description": "medium represents what type of storage medium should back this directory. The default is \"\" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir",
    122                    "type": "string",
    123                },
    124                "sizeLimit": ({
    125                    let mut schema_obj = __gen.subschema_for::<crate::apimachinery::pkg::api::resource::Quantity>();
    126                    schema_obj.ensure_object().insert("description".into(), "sizeLimit is the total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir".into());
    127                    schema_obj
    128                }),
    129            },
    130        })
    131    }
    132}